<?php

defined('ABSPATH') || exit;

class Koala_WMSA_Ajax {

	public function __construct() {

		// Front Ajax.
		add_action('wp_ajax_koala_country_state_ajax', array( $this, 'koala_country_state_ajax' ));

		add_action('wp_ajax_kawmsa_update_addresses', array( $this, 'kawmsa_update_addresses' ));

		add_action('wp_ajax_save_radio_state_front', array( $this, 'save_radio_state_front' ));

		add_action('wp_ajax_wmsa_address_data_ajax', array( $this, 'wmsa_address_data_ajax' ));

		// Admin Ajax.
		add_action('wp_ajax_koala_multi_address_get_country_state', array( $this, 'koala_multi_address_get_country_state' ));

		add_action('wp_ajax_save_radio_state', array( $this, 'save_radio_state' ));

		add_action('wp_ajax_woocommerce_auto_processing_orders', array( $this, 'woocommerce_auto_processing_orders' ));
		add_action('wp_ajax_update_form', array( $this, 'update_form' ));

		add_action('wp_ajax_nopriv_update_form', array( $this, 'update_form' ));
	}


	public function update_form() {

		$nonce = isset($_POST['nonce']) ? sanitize_text_field( $_POST['nonce'] ) : 0;
		if ( ! wp_verify_nonce($nonce, 'multi_address_nonce_admin') ) {
			wp_die(esc_html__('Security Violated!', 'koala-multiple-customer-addresses'));
		}

		if (isset($_POST['data'])) {

				//$data = sanitize_text_field($_POST['data']);
			$data = filter_var($_POST['data'], FILTER_SANITIZE_STRING);


			parse_str($data, $split_cart_array);


			$new_items_array    = array();
			$update_items_array = array();
			$remove_items_array = array();


			$addresses  = isset( $split_cart_array['multi_address'] ) ? $split_cart_array['multi_address'] : array();
			$quantities = isset( $split_cart_array['item_multi_address'] ) ? $split_cart_array['item_multi_address'] : array();

			$user_id = get_current_user_id();

			$custom_shipping_info =  get_user_meta( $user_id, 'msadd_custom_address', true);
			
			$default_address =  get_user_meta($user_id, 'street_address_billing', true);

			$cart_contents = wc()->cart->get_cart_contents();

			echo '<pre>';

			$product_details = $split_cart_array['item_multi_address'];
			unset( $product_details['cart_key'] );

			$product_and_address_details_array = array();
				$get_cart_contents = WC()->cart->get_cart();


			foreach ($product_details as $cart_key => $product_with_address_details) {

				if ( ! isset( $get_cart_contents[ $cart_key ] ) ) {
					continue;
				}
				$cart_item = $get_cart_contents[ $cart_key ];

				foreach ($product_with_address_details as $key => $value) {
					$cart_items = array();
						
					$quantity  = isset( $value['qty'] ) ?  $value['qty'] : 1;
					$cart_items['address'] =  isset( $value['address'] ) ?  $value['address'] : '';

			
					$product_and_address_details_array[] =array(
						'product_id' => $cart_item['product_id'],
						'variation_id' => $cart_item['variation_id'],
						'variation' => $cart_item['variation'],
						'quantity' => $quantity,
						'cart_items' => $cart_items,
						'cart_key' => $cart_key,
					);

					
				wc()->cart->remove_cart_item( $cart_key );


				}

			}
			
			echo '<pre>';

			print_r( $product_and_address_details_array );
			print_r( $product_details );
			// exit();
			foreach ( $product_and_address_details_array as $item ) {

				if ( is_array($item) && isset( $item['product_id'] ) ) {
				

				$new_Cart_key = wc()->cart->add_to_cart( $item['product_id'], $item['quantity'], $item['variation_id'], $item['variation'], $item['cart_items']);


				}
			}


			exit;   


		}
	}

	public function woocommerce_auto_processing_orders() {

		$nonce = isset($_POST['nonce']) ? sanitize_text_field( $_POST['nonce'] ) : 0;
		if ( ! wp_verify_nonce($nonce, 'multi_address_nonce_admin') ) {
			wp_die(esc_html__('Security Violated!', 'koala-multiple-customer-addresses'));
		}

		if (isset($_POST['order_status_completed'])) {
			$order_id = isset($_POST['order_status_completed']) ? sanitize_text_field($_POST['order_status_completed']) : '';
			$order    = new WC_Order($order_id);
			$order->update_status('completed');
		}
		if (isset($_POST['order_status_processing'])) {
			$order_id = isset($_POST['order_status_processing']) ? sanitize_text_field($_POST['order_status_processing']) : '';
			$order    = new WC_Order($order_id);
			$order->update_status('processing');
		}
		wp_die();
	}

	public function save_radio_state() {

		$nonce = isset($_POST['nonce']) ? sanitize_text_field( $_POST['nonce'] ) : 0;
		if ( ! wp_verify_nonce($nonce, 'multi_address_nonce_admin') ) {
			wp_die(esc_html__('Security Violated!', 'koala-multiple-customer-addresses'));
		}

		if (isset($_POST['default_shipping_meta'])) {
			$user_id = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$radio   = isset($_POST['default_shipping_meta']) ? sanitize_text_field($_POST['default_shipping_meta']) : '';
			update_user_meta($user_id, 'default_shipping_meta', $radio);
		}

		if (isset($_POST['default_billing_meta'])) {
			$user_id       = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$radio_billing = isset($_POST['default_billing_meta']) ? sanitize_text_field($_POST['default_billing_meta']) : '';
			update_user_meta($user_id, 'default_billing_meta', $radio_billing);
		}

		die();
	}

	public function koala_multi_address_get_country_state() {

		$nonce = isset($_POST['nonce']) ? sanitize_text_field( $_POST['nonce'] ) : 0;
		if ( ! wp_verify_nonce($nonce, 'multi_address_nonce_admin') ) {
			wp_die(esc_html__('Security Violated!', 'koala-multiple-customer-addresses'));
		}

		if (isset($_POST['billing_form_edit'])) {
			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta($user_id, 'all_billing_address', true);
			$id           = isset($_POST['edit_id_billing']) ? sanitize_text_field($_POST['edit_id_billing']) : '';
			$a            = 0;
			update_user_meta($user_id, 'all_billing_address', $a);
			foreach ($all_shipping as $key => $value) {
				if ($key != $id) {
					$idname      = $all_shipping[ $key ]['address_identifier_billing'];
					$fname       = $all_shipping[ $key ]['first_name_billing'];
					$lname       = $all_shipping[ $key ]['last_name_billing'];
					$cname       = $all_shipping[ $key ]['copmany_name_billing'];
					$country     = $all_shipping[ $key ]['country_billing'];
					$state       = $all_shipping[ $key ]['country_state'];
					$street      = $all_shipping[ $key ]['street_address_billing'];
					$street2     = $all_shipping[ $key ]['street_address_billing2'];
					$town        = $all_shipping[ $key ]['town_address_billing'];
					$postal      = $all_shipping[ $key ]['postal_code_billing'];
					$phone       = $all_shipping[ $key ]['phone_billing'];
					$email       = $all_shipping[ $key ]['email_billing'];
					$new         = array();
					$new_history = array();
					$new[]       = array(
						'address_identifier_billing' => $idname,
						'first_name_billing'         => $fname,
						'last_name_billing'          => $lname,
						'copmany_name_billing'       => $cname,
						'country_billing'            => $country,
						'country_state'              => $state,
						'street_address_billing'     => $street,
						'street_address_billing2'    => $street2,
						'town_address_billing'       => $town,
						'postal_code_billing'        => $postal,
						'phone_billing'              => $phone,
						'email_billing'              => $email,
					);
					$new_history = get_user_meta($user_id, 'all_billing_address', true);
					if (!empty($new_history)) {
						$new_history1 = $new_history;
					} else {
						$new_history1 = array();
					}
					$arr1 = array();
					$arr1 = array_merge($new_history1, $new);
					update_user_meta($user_id, 'all_billing_address', $arr1);
				} else {
					$fname       = isset($_POST['first_name_billing_edit']) ? sanitize_text_field($_POST['first_name_billing_edit']) : '';
					$lname       = isset($_POST['last_name_billing_edit']) ? sanitize_text_field($_POST['last_name_billing_edit']) : '';
					$cname       = isset($_POST['copmany_name_billing_edit']) ? sanitize_text_field($_POST['copmany_name_billing_edit']) : '';
					$country     = isset($_POST['country_name_billing_edit']) ? sanitize_text_field($_POST['country_name_billing_edit']) : '';
					$state       = isset($_POST['add_billing_state_edit']) ? sanitize_text_field($_POST['add_billing_state_edit']) : '';
					$street      = isset($_POST['st_address_billing_edit']) ? sanitize_text_field($_POST['st_address_billing_edit']) : '';
					$street2     = isset($_POST['st_address_billing_edit2']) ? sanitize_text_field($_POST['st_address_billing_edit2']) : '';
					$town        = isset($_POST['town_address_billing_edit']) ? sanitize_text_field($_POST['town_address_billing_edit']) : '';
					$postal      = isset($_POST['postal_code_billing_edit']) ? sanitize_text_field($_POST['postal_code_billing_edit']) : '';
					$phone       = isset($_POST['phone_billing_edit']) ? sanitize_text_field($_POST['phone_billing_edit']) : '';
					$email       = isset($_POST['email_billing_edit']) ? sanitize_text_field($_POST['email_billing_edit']) : '';
					$idname      = isset($_POST['identifier_name_billing_edit']) ? sanitize_text_field($_POST['identifier_name_billing_edit']) : '';
					$new         = array();
					$new_history = array();
					$new[]       = array(
						'address_identifier_billing' => $idname,
						'first_name_billing'         => $fname,
						'last_name_billing'          => $lname,
						'copmany_name_billing'       => $cname,
						'country_billing'            => $country,
						'country_state'              => $state,
						'street_address_billing'     => $street,
						'street_address_billing2'    => $street2,
						'town_address_billing'       => $town,
						'postal_code_billing'        => $postal,
						'phone_billing'              => $phone,
						'email_billing'              => $email,
					);
					$new_history = get_user_meta($user_id, 'all_billing_address', true);
					if (!empty($new_history)) {
						$new_history1 = $new_history;
					} else {
						$new_history1 = array();
					}
					$arr1 = array();
					$arr1 = array_merge($new_history1, $new);
					update_user_meta($user_id, 'all_billing_address', $arr1);
				}
			}
		}
		if (isset($_POST['shipping_form_edit'])) {
			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta($user_id, 'all_shipping_address', true);
			$id           = isset($_POST['edit_id_shipping']) ? sanitize_text_field($_POST['edit_id_shipping']) : '';
			$a            = 0;
			update_user_meta($user_id, 'all_shipping_address', $a);
			foreach ($all_shipping as $key => $value) {
				if ($key != $id) {
					$idname      = $all_shipping[ $key ]['address_identifier_shipping'];
					$fname       = $all_shipping[ $key ]['first_name_shipping'];
					$lname       = $all_shipping[ $key ]['last_name_shipping'];
					$cname       = $all_shipping[ $key ]['copmany_name_shipping'];
					$country     = $all_shipping[ $key ]['country_name_shipping'];
					$state       = $all_shipping[ $key ]['country_state_shipping'];
					$street      = $all_shipping[ $key ]['street_address_shipping'];
					$street2     = $all_shipping[ $key ]['street_address_shipping2'];
					$town        = $all_shipping[ $key ]['town_address_shipping'];
					$pin         = $all_shipping[ $key ]['pin_code_shipping'];
					$phone       = $all_shipping[ $key ]['phone_shipping'];
					$email       = $all_shipping[ $key ]['email_shipping'];
					$new         = array();
					$new_history = array();
					$new[ $key ]   = array(
						'address_identifier_shipping' => $idname,
						'first_name_shipping'         => $fname,
						'last_name_shipping'          => $lname,
						'copmany_name_shipping'       => $cname,
						'country_name_shipping'       => $country,
						'country_state_shipping'      => $state,
						'street_address_shipping'     => $street,
						'street_address_shipping2'    => $street2,
						'town_address_shipping'       => $town,
						'pin_code_shipping'           => $pin,
						'phone_shipping'              => $phone,
						'email_shipping'              => $email,
					);
					$new_history = get_user_meta($user_id, 'all_shipping_address', true);
					if (!empty($new_history)) {
						$new_history1 = $new_history;
					} else {
						$new_history1 = array();
					}
					$arr1 = array();
					$arr1 = array_replace_recursive($new_history1, $new);
					update_user_meta($user_id, 'all_shipping_address', $arr1);
				} else {
					$user_id = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';

					$fname = isset($_POST['first_name_shipping_edit']) ? sanitize_text_field($_POST['first_name_shipping_edit']) : '';

					$lname = isset($_POST['last_name_shipping_edit']) ? sanitize_text_field($_POST['last_name_shipping_edit']) : '';

					$cname = isset($_POST['copmany_name_shipping_edit']) ? sanitize_text_field($_POST['copmany_name_shipping_edit']) : '';

					$country = isset($_POST['country_name_shipping_edit']) ? sanitize_text_field($_POST['country_name_shipping_edit']) : '';
					$state   = isset($_POST['add_shipping_state_edit']) ? sanitize_text_field($_POST['add_shipping_state_edit']) : '';

					$street = isset($_POST['st_address_shipping_edit']) ? sanitize_text_field($_POST['st_address_shipping_edit']) : '';

					$street2 = isset($_POST['st_address_shipping2_edit']) ? sanitize_text_field($_POST['st_address_shipping2_edit']) : '';
					$town    = isset($_POST['town_address_shipping_edit']) ? sanitize_text_field($_POST['town_address_shipping_edit']) : '';
					$pin     = isset($_POST['pin_code_shipping_edit']) ? sanitize_text_field($_POST['pin_code_shipping_edit']) : '';

					$idname = isset($_POST['identifier_name_shipping_edit']) ? sanitize_text_field($_POST['identifier_name_shipping_edit']) : '';

					$add_shipping_phone = get_option('add_shipping_phone_option');
					if ('1' === $add_shipping_phone) {
						$phone = isset($_POST['phone_shipping_edit']) ? sanitize_text_field($_POST['phone_shipping_edit']) : '';
					} else {
						$phone = '';
					}

					$add_shipping_email = get_option('add_shipping_email_option');
					if ('1' === $add_shipping_email) {
						$email = isset($_POST['email_shipping_edit']) ? sanitize_text_field($_POST['email_shipping_edit']) : '';
					} else {
						$email = '';
					}
					$new         = array();
					$new_history = array();
					$new[ $id ]    = array(
						'address_identifier_shipping' => $idname,
						'first_name_shipping'         => $fname,
						'last_name_shipping'          => $lname,
						'copmany_name_shipping'       => $cname,
						'country_name_shipping'       => $country,
						'country_state_shipping'      => $state,
						'street_address_shipping'     => $street,
						'street_address_shipping2'    => $street2,
						'town_address_shipping'       => $town,
						'pin_code_shipping'           => $pin,
						'phone_shipping'              => $phone,
						'email_shipping'              => $email,
					);
					$new_history = get_user_meta($user_id, 'all_shipping_address', true);
					if (!empty($new_history)) {
						$new_history1 = $new_history;
					} else {
						$new_history1 = array();
					}
					$arr1 = array();
					$arr1 = array_replace_recursive($new_history1, $new);
					update_user_meta($user_id, 'all_shipping_address', $arr1);
				}
			}
		}

		if (isset($_POST['duplicate_shipping'])) {
			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta($user_id, 'all_shipping_address', true);
			$a1           = isset($_POST['duplicate_shipping']) ? sanitize_text_field($_POST['duplicate_shipping']) : '';
			$idname       = $all_shipping[ $a1 ]['address_identifier_shipping'];
			$fname        = $all_shipping[ $a1 ]['first_name_shipping'];
			$lname        = $all_shipping[ $a1 ]['last_name_shipping'];
			$cname        = $all_shipping[ $a1 ]['copmany_name_shipping'];
			$country      = $all_shipping[ $a1 ]['country_name_shipping'];
			$state        = $all_shipping[ $a1 ]['country_state_shipping'];
			$street       = $all_shipping[ $a1 ]['street_address_shipping'];
			$street2      = $all_shipping[ $a1 ]['street_address_shipping2'];
			$town         = $all_shipping[ $a1 ]['town_address_shipping'];
			$pin          = $all_shipping[ $a1 ]['pin_code_shipping'];
			$phone        = $all_shipping[ $a1 ]['phone_shipping'];
			$email        = $all_shipping[ $a1 ]['email_shipping'];
			$new          = array();
			$new_history  = array();
			$new[]        = array(
				'address_identifier_shipping' => $idname,
				'first_name_shipping'         => $fname,
				'last_name_shipping'          => $lname,
				'copmany_name_shipping'       => $cname,
				'country_name_shipping'       => $country,
				'country_state_shipping'      => $state,
				'street_address_shipping'     => $street,
				'street_address_shipping2'    => $street2,
				'town_address_shipping'       => $town,
				'pin_code_shipping'           => $pin,
				'phone_shipping'              => $phone,
				'email_shipping'              => $email,
			);
			$new_history  = get_user_meta($user_id, 'all_shipping_address', true);
			if (!empty($new_history)) {
				$new_history1 = $new_history;
			} else {
				$new_history1 = array();
			}
			$arr1 = array();
			$arr1 = array_merge($new_history1, $new);
			update_user_meta($user_id, 'all_shipping_address', $arr1);
			wp_die();
		}

		if (isset($_POST['duplicate_billing'])) {
			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta($user_id, 'all_billing_address', true);
			$a1           = isset($_POST['duplicate_billing']) ? sanitize_text_field($_POST['duplicate_billing']) : '';
			$idname       = $all_shipping[ $a1 ]['address_identifier_billing'];
			$fname        = $all_shipping[ $a1 ]['first_name_billing'];
			$lname        = $all_shipping[ $a1 ]['last_name_billing'];
			$cname        = $all_shipping[ $a1 ]['copmany_name_billing'];
			$country      = $all_shipping[ $a1 ]['country_billing'];
			$state        = $all_shipping[ $a1 ]['country_state'];
			$street       = $all_shipping[ $a1 ]['street_address_billing'];
			$street2      = $all_shipping[ $a1 ]['street_address_billing2'];
			$town         = $all_shipping[ $a1 ]['town_address_billing'];
			$postal_code  = $all_shipping[ $a1 ]['postal_code_billing'];
			$phone        = $all_shipping[ $a1 ]['phone_billing'];
			$email        = $all_shipping[ $a1 ]['email_billing'];
			$new          = array();
			$new_history  = array();
			$new[]        = array(
				'address_identifier_billing' => $idname,
				'first_name_billing'         => $fname,
				'last_name_billing'          => $lname,
				'copmany_name_billing'       => $cname,
				'country_billing'            => $country,
				'country_state'              => $state,
				'street_address_billing'     => $street,
				'street_address_billing2'    => $street2,
				'town_address_billing'       => $town,
				'postal_code_billing'        => $postal_code,
				'phone_billing'              => $phone,
				'email_billing'              => $email,
			);
			$new_history  = get_user_meta($user_id, 'all_billing_address', true);
			if (!empty($new_history)) {
				$new_history1 = $new_history;
			} else {
				$new_history1 = array();
			}
			$arr1 = array();
			$arr1 = array_merge($new_history1, $new);
			update_user_meta($user_id, 'all_billing_address', $arr1);
		}
		if (isset($_POST['delete_address_shipping'])) {
			$user_id              = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping         = get_user_meta($user_id, 'all_shipping_address', true);
			$radio_state_shipping = get_user_meta($user_id, 'default_shipping_meta', true);
			$a1                   = isset($_POST['delete_address_shipping']) ? sanitize_text_field($_POST['delete_address_shipping']) : '';
			$a                    = 'b';
			if ($a1 == $radio_state_shipping) {
				update_user_meta($user_id, 'default_shipping_meta', $a);
			}
			unset($all_shipping[ $a1 ]);
			update_user_meta($user_id, 'all_shipping_address', $all_shipping);
			wp_die();
		}
		if (isset($_POST['delete_address_billing'])) {
			$user_id     = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_billing = get_user_meta($user_id, 'all_billing_address', true);
			$radio_state = get_user_meta($user_id, 'default_billing_meta', true);
			$a1          = isset($_POST['delete_address_billing']) ? sanitize_text_field($_POST['delete_address_billing']) : '';
			$b           = 'a';
			if ($a1 == $radio_state) {
				update_user_meta($user_id, 'default_billing_meta', $b);
			}
			unset($all_billing[ $a1 ]);
			update_user_meta($user_id, 'all_billing_address', $all_billing);
		}

		if (isset($_POST['shipping_form_submit'])) {
			$user_id     = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$fname       = isset($_POST['first_name_shipping']) ? sanitize_text_field($_POST['first_name_shipping']) : '';
			$lname       = isset($_POST['last_name_shipping']) ? sanitize_text_field($_POST['last_name_shipping']) : '';
			$cname       = isset($_POST['copmany_name_shipping']) ? sanitize_text_field($_POST['copmany_name_shipping']) : '';
			$country     = isset($_POST['country_name_shipping']) ? sanitize_text_field($_POST['country_name_shipping']) : '';
			$state       = isset($_POST['add_shipping_state']) ? sanitize_text_field($_POST['add_shipping_state']) : '';
			$street      = isset($_POST['st_address_shipping']) ? sanitize_text_field($_POST['st_address_shipping']) : '';
			$street2     = isset($_POST['st_address_shipping2']) ? sanitize_text_field($_POST['st_address_shipping2']) : '';
			$town        = isset($_POST['town_address_shipping']) ? sanitize_text_field($_POST['town_address_shipping']) : '';
			$pin         = isset($_POST['pin_code_shipping']) ? sanitize_text_field($_POST['pin_code_shipping']) : '';
			$idname      = isset($_POST['identifier_name_shipping']) ? sanitize_text_field($_POST['identifier_name_shipping']) : '';
			$phone       = isset($_POST['phone_shipping']) ? sanitize_text_field($_POST['phone_shipping']) : '';
			$email       = isset($_POST['email_shipping']) ? sanitize_text_field($_POST['email_shipping']) : '';
			$new         = array();
			$new_history = array();
			$new[]       = array(
				'address_identifier_shipping' => $idname,
				'first_name_shipping'         => $fname,
				'last_name_shipping'          => $lname,
				'copmany_name_shipping'       => $cname,
				'country_name_shipping'       => $country,
				'country_state_shipping'      => $state,
				'street_address_shipping'     => $street,
				'street_address_shipping2'    => $street2,
				'town_address_shipping'       => $town,
				'pin_code_shipping'           => $pin,
				'phone_shipping'              => $phone,
				'email_shipping'              => $email,
			);
			$new_history = get_user_meta($user_id, 'all_shipping_address', true);
			if (!empty($new_history)) {
				$new_history1 = $new_history;
			} else {
				$new_history1 = array();
			}
			$arr1 = array();
			$arr1 = array_merge($new_history1, $new);
			update_user_meta($user_id, 'all_shipping_address', $arr1);
		}
		if (isset($_POST['billing_form_submit'])) {

			$user_id     = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$fname       = isset($_POST['first_name_billing']) ? sanitize_text_field($_POST['first_name_billing']) : '';
			$lname       = isset($_POST['last_name_billing']) ? sanitize_text_field($_POST['last_name_billing']) : '';
			$cname       = isset($_POST['copmany_name_billing']) ? sanitize_text_field($_POST['copmany_name_billing']) : '';
			$country     = isset($_POST['country_name_billing']) ? sanitize_text_field($_POST['country_name_billing']) : '';
			$state       = isset($_POST['add_billing_state']) ? sanitize_text_field($_POST['add_billing_state']) : '';
			$street      = isset($_POST['st_address_billing']) ? sanitize_text_field($_POST['st_address_billing']) : '';
			$street2     = isset($_POST['st_address_billing2']) ? sanitize_text_field($_POST['st_address_billing2']) : '';
			$town        = isset($_POST['town_address_billing']) ? sanitize_text_field($_POST['town_address_billing']) : '';
			$postal_code = isset($_POST['postal_code_billing']) ? sanitize_text_field($_POST['postal_code_billing']) : '';
			$phone       = isset($_POST['phone_billing']) ? sanitize_text_field($_POST['phone_billing']) : '';
			$email       = isset($_POST['email_billing']) ? sanitize_text_field($_POST['email_billing']) : '';
			if (isset($_POST['identifier_name_billing'])) {
				$idname = sanitize_text_field(wp_unslash($_POST['identifier_name_billing']));
			} else {
				$idname = $fname . $lname . $street . $country . $town;
			}
			$new         = array();
			$new_history = array();
			$new[]       = array(
				'address_identifier_billing' => $idname,
				'first_name_billing'         => $fname,
				'last_name_billing'          => $lname,
				'copmany_name_billing'       => $cname,
				'country_billing'            => $country,
				'country_state'              => $state,
				'street_address_billing'     => $street,
				'street_address_billing2'    => $street2,
				'town_address_billing'       => $town,
				'postal_code_billing'        => $postal_code,
				'phone_billing'              => $phone,
				'email_billing'              => $email,
			);
			$new_history = get_user_meta($user_id, 'all_billing_address', true);
			if (!empty($new_history)) {
				$new_history1 = $new_history;
			} else {
				$new_history1 = array();
			}
			$arr1 = array();
			$arr1 = array_merge($new_history1, $new);
			update_user_meta($user_id, 'all_billing_address', $arr1);
		}

		if (isset($_POST['koala_multi_country_state_edit_shipping_privious'])) {
			$country = isset($_POST['koala_multi_country_state_edit_shipping_privious']) ? sanitize_text_field($_POST['koala_multi_country_state_edit_shipping_privious']) : '';
			$user_id = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$state_name;
			$country_name;
			$shipping_privious_state = get_user_meta($user_id, 'all_shipping_address', true);
			foreach ($shipping_privious_state as $key => $value) {
				if ($key == $country) {
					$country_name = $shipping_privious_state[ $key ]['country_name_shipping'];
					$state_name   = $shipping_privious_state[ $key ]['country_state_shipping'];
				}
			}
			$countr_obj = new WC_Countries();
			$a          = $countr_obj->get_states($country_name);
			?>
			<?php
			$b = 0;
			foreach ($a as $value) {
				if ($value == $state_name) {
					$b++;
				}
			}
			if ($b > 0) {
				?>
				<label class="mylabel"><?php esc_html_e('States', 'koala-multiple-customer-addresses'); ?><span class="required">*</span></label><br>
				<select name="country_state_shipping_edit" value="BA">
					<?php
					foreach ($a as $key => $value) {
						if ($value == $state_name) {
							?>
							<option selected="selected">
								<?php
								echo esc_html__($value);
								?>
							</option>
							<?php
						} else {
							?>
							<option>
								<?php
								echo esc_html__($value);
								?>
							</option>
							<?php
						}
					}
					?>
				</select>
				<?php
			} else {
				?>
				<label class="mylabel"><?php esc_html_e('County (optional)', 'koala-multiple-customer-addresses'); ?></label><br>
				<input type="text" name="state_saved_name" value="<?php echo esc_html($state_name); ?>">
				<?php
			}
			die();
		}
		if (isset($_POST['koala_multi_country_state_edit_billing_privious'])) {
			$country = isset($_POST['koala_multi_country_state_edit_billing_privious']) ? sanitize_text_field($_POST['koala_multi_country_state_edit_billing_privious']) : '';
			$user_id = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$state_name;
			$country_name;
			$shipping_privious_state = get_user_meta($user_id, 'all_billing_address', true);
			foreach ($shipping_privious_state as $key => $value) {
				if ($key == $country) {
					$country_name = $shipping_privious_state[ $key ]['country_billing'];
					$state_name   = $shipping_privious_state[ $key ]['country_state'];
				}
			}
			$countr_obj = new WC_Countries();
			$a          = $countr_obj->get_states($country_name);
			?>
			<?php
			$b = 0;
			foreach ($a as $value) {
				if ($value == $state_name) {
					$b++;
				}
			}
			if ($b > 0) {
				?>
				<label class="mylabel">State<span class="required">*</span></label><br>
				<select name="country_state_billing_edit">
					<?php
					foreach ($a as $key => $value) {
						if ($value == $state_name) {
							?>

							<option selected="selected">
								<?php
								echo esc_html__($value);
								?>
							</option>
							<?php
						} else {
							?>

							<option>
								<?php
								echo esc_html__($value);
								?>
							</option>
							<?php
						}
					}
					?>
				</select>
				<?php
			} else {
				?>
				<label class="mylabel">State</label><br>
				<input type="text" name="state_saved_name_billing" value="<?php echo esc_html($state_name); ?>">
				<?php
			}
			die();
		}
		if (isset($_POST['koala_multi_country_state_edit_shipping'])) {
			$country    = isset($_POST['koala_multi_country_state_edit_shipping']) ? sanitize_text_field($_POST['koala_multi_country_state_edit_shipping']) : '';
			$countr_obj = new WC_Countries();
			$a          = $countr_obj->get_states($country);
			?>
			<?php
			if (!empty($a)) {
				?>
				<label class="mylabel"><?php esc_html_e('State', 'koala-multiple-customer-addresses'); ?><span class="required">*</span></label><br>
				<select name="country_state_shipping_edit">
					<?php
					foreach ($a as $value) {
						?>
						<option>
							<?php
							echo esc_html__($value);
							?>
						</option>
						<?php
					}
					?>
				</select>
				<?php
			} else {
				?>
				<label class="mylabel"><?php esc_html_e('County (optional)', 'koala-multiple-customer-addresses'); ?></label><br>
				<input type="Text" name="get_input_state_shipping_edit">
				<?php
			}
			die();
		}
		if (isset($_POST['koala_multi_country_state_edit_billing'])) {
			$country    = isset($_POST['koala_multi_country_state_edit_billing']) ? sanitize_text_field($_POST['koala_multi_country_state_edit_billing']) : '';
			$countr_obj = new WC_Countries();
			$a          = $countr_obj->get_states($country);
			?>
			<?php
			if (!empty($a)) {
				?>
				<label class="mylabel"><?php esc_html_e('State', 'koala-multiple-customer-addresses'); ?><span class="required">*</span></label><br>
				<select name="country_state_billing_edit">
					<?php
					foreach ($a as $value) {
						?>
						<option>
							<?php
							echo esc_html__($value);
							?>
						</option>
						<?php
					}
					?>
				</select>
				<?php
			} else {
				?>
				<label class="mylabel"><?php esc_html_e('County (optional)', 'koala-multiple-customer-addresses'); ?></label><br>
				<input type="Text" name="get_input_state_billing_edit">
				<?php
			}
			die();
		}

		if (isset($_POST['koala_multi_country_state_add_billing'])) {
			$country    = isset($_POST['koala_multi_country_state_add_billing']) ? sanitize_text_field($_POST['koala_multi_country_state_add_billing']) : '';
			$countr_obj = new WC_Countries();
			$a          = $countr_obj->get_states($country);
			?>
			<?php
			if (!empty($a)) {
				?>
				<label class="mylabel"><?php esc_html_e('State', 'koala-multiple-customer-addresses'); ?><span class="required">*</span></label><br>
				<select name="add_billing_state">
					<?php
					foreach ($a as $value) {
						?>
						<option>
							<?php
							echo esc_html__($value);
							?>
						</option>
						<?php
					}
					?>

				</select>
				<?php
			} else {
				?>
				<label class="mylabel"><?php esc_html_e('County (optional)', 'koala-multiple-customer-addresses'); ?></label><br>
				<input type="Text" name="get_input_state_billing">
				<?php
			}
			die();
		}

		if (isset($_POST['koala_multi_country_state_add_shipping'])) {
			$country    = isset($_POST['koala_multi_country_state_add_shipping']) ? sanitize_text_field($_POST['koala_multi_country_state_add_shipping']) : '';
			$countr_obj = new WC_Countries();
			$a          = $countr_obj->get_states($country);
			?>
			<?php
			if (!empty($a)) {
				?>
				<label class="mylabel"><?php esc_html_e('State', 'koala-multiple-customer-addresses'); ?><span class="required">*</span></label><br>
				<select name="add_shipping_state">
					<?php
					foreach ($a as $value) {
						?>
						<option>
							<?php
							echo esc_html__($value);
							?>
						</option>
						<?php
					}
					?>
				</select>
				<?php
			} else {
				?>
				<label class="mylabel"><?php esc_html_e('County (optional)', 'koala-multiple-customer-addresses'); ?></label><br>
				<input type="Text" name="get_input_state_shipping">
				<?php
			}
			die();
		}

		if (isset($_POST['address_id'])) {
			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta($user_id, 'all_shipping_address', true);
			$id           = isset($_POST['address_id']) ? sanitize_text_field($_POST['address_id']) : '';
			foreach ($all_shipping as $key => $value) {
				if ($key == $id) {
					$idname  = $all_shipping[ $key ]['address_identifier_shipping'];
					$fname   = $all_shipping[ $key ]['first_name_shipping'];
					$lname   = $all_shipping[ $key ]['last_name_shipping'];
					$cname   = $all_shipping[ $key ]['copmany_name_shipping'];
					$country = $all_shipping[ $key ]['country_name_shipping'];
					$state   = $all_shipping[ $key ]['country_state_shipping'];
					$street  = $all_shipping[ $key ]['street_address_shipping'];
					$street2 = $all_shipping[ $key ]['street_address_shipping2'];
					$town    = $all_shipping[ $key ]['town_address_shipping'];
					$pin     = $all_shipping[ $key ]['pin_code_shipping'];
				}
			}
			$countr_obj = new WC_Countries();
			$state_code = 'abc';
			$a          = $countr_obj->get_states($country);
			if (!empty($a)) {
				foreach ($a as $key => $value) {
					if ($value == $state) {
						$state_code = $key;
					}
				}
				$state = $state_code;
			}
			update_user_meta($user_id, 'shipping_first_name', $fname);
			update_user_meta($user_id, 'shipping_last_name', $lname);
			update_user_meta($user_id, 'shipping_company', $cname);
			update_user_meta($user_id, 'shipping_country', $country);
			update_user_meta($user_id, 'shipping_state', $state);
			update_user_meta($user_id, 'shipping_city', $town);
			update_user_meta($user_id, 'shipping_postcode', $pin);
			update_user_meta($user_id, 'shipping_address_1', $street);
			update_user_meta($user_id, 'shipping_address_2', $street2);
		}
		if (isset($_POST['address_id_billing'])) {
			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta($user_id, 'all_billing_address', true);
			$id           = isset($_POST['address_id_billing']) ? sanitize_text_field($_POST['address_id_billing']) : '';
			foreach ($all_shipping as $key => $value) {
				if ($key == $id) {
					$idname  = $all_shipping[ $key ]['address_identifier_billing'];
					$fname   = $all_shipping[ $key ]['first_name_billing'];
					$lname   = $all_shipping[ $key ]['last_name_billing'];
					$cname   = $all_shipping[ $key ]['copmany_name_billing'];
					$country = $all_shipping[ $key ]['country_billing'];
					$state   = $all_shipping[ $key ]['country_state'];
					$street  = $all_shipping[ $key ]['street_address_billing'];
					$street2 = $all_shipping[ $key ]['street_address_billing2'];
					$town    = $all_shipping[ $key ]['town_address_billing'];
					$postal  = $all_shipping[ $key ]['postal_code_billing'];
					$phone   = $all_shipping[ $key ]['phone_billing'];
					$email   = $all_shipping[ $key ]['email_billing'];
				}
			}
			$countr_obj = new WC_Countries();
			$state_code = 'abc';
			$a          = $countr_obj->get_states($country);
			if (!empty($a)) {
				foreach ($a as $key => $value) {
					if ($value == $state) {
						$state_code = $key;
					}
				}
				$state = $state_code;
			}
			update_user_meta($user_id, 'billing_first_name', $fname);
			update_user_meta($user_id, 'billing_last_name', $lname);
			update_user_meta($user_id, 'billing_company', $cname);
			update_user_meta($user_id, 'billing_country', $country);
			update_user_meta($user_id, 'billing_state', $state);
			update_user_meta($user_id, 'billing_city', $town);
			update_user_meta($user_id, 'billing_postcode', $postal);
			update_user_meta($user_id, 'billing_address_1', $street);
			update_user_meta($user_id, 'billing_address_2', $street2);
			update_user_meta($user_id, 'billing_email', $email);
			update_user_meta($user_id, 'billing_phone', $phone);
		}
	}

	public function save_radio_state_front() {

		$nonce = isset($_POST['nonce']) ? sanitize_text_field( $_POST['nonce'] ) : 0;
		if ( ! wp_verify_nonce($nonce, 'multi_address_nonce_admin') ) {
			wp_die(esc_html__('Security Violated!', 'koala-multiple-customer-addresses'));
		}

		if (isset($_POST['default_billing_meta_front'])) {
			$user_id = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$radio   = sanitize_meta('', wp_unslash($_POST['default_billing_meta_front']), '');
		}
		if (isset($radio)) {
			$a = update_user_meta($user_id, 'default_billing_meta', $radio);
		}

		if (isset($_POST['default_shipping_meta_front'])) {
			$user_id        = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$radio_shipping = sanitize_meta('', wp_unslash($_POST['default_shipping_meta_front']), '');
		}
		if (isset($radio_shipping)) {
			$a = update_user_meta($user_id, 'default_shipping_meta', $radio_shipping);
		}
		wp_die();
	}

	public function koala_country_state_ajax() {

		$nonce = isset($_POST['nonce']) ? sanitize_text_field( $_POST['nonce'] ) : 0;

		if ( ! wp_verify_nonce($nonce, 'multi_address_nonce_admin') ) {
			wp_die(esc_html__('Security Violated!', 'koala-multiple-customer-addresses'));
		}
		if (isset($_POST['cart_billing_form'])) {
			$fname       = isset($_POST['fname']) ? sanitize_text_field($_POST['fname']) : '';
			$lname       = isset($_POST['lname']) ? sanitize_text_field($_POST['lname']) : '';
			$cname       = isset($_POST['cname']) ? sanitize_text_field($_POST['cname']) : '';
			$country     = isset($_POST['country']) ? sanitize_text_field($_POST['country']) : '';
			$state       = isset($_POST['state']) ? sanitize_text_field($_POST['state']) : '';
			$street      = isset($_POST['street1']) ? sanitize_text_field($_POST['street1']) : '';
			$street2     = isset($_POST['street2']) ? sanitize_text_field($_POST['street2']) : '';
			$town        = isset($_POST['town']) ? sanitize_text_field($_POST['town']) : '';
			$postal_code = isset($_POST['postal']) ? sanitize_text_field($_POST['postal']) : '';
			$phone       = isset($_POST['phone']) ? sanitize_text_field($_POST['phone']) : '';
			$email       = isset($_POST['email']) ? sanitize_text_field($_POST['email']) : '';

			if (isset($_POST['idname'])) {
				$idname = isset($_POST['idname']) ? sanitize_text_field($_POST['idname']) : '';
			} else {
				$idname = $fname . ' ' . $lname . $street . $country . $town;
			}

			$new         = array();
			$new_history = array();
			$new[]       = array(
				'address_identifier_billing' => $idname,
				'first_name_billing'         => $fname,
				'last_name_billing'          => $lname,
				'copmany_name_billing'       => $cname,
				'country_billing'            => $country,
				'country_state'              => $state,
				'street_address_billing'     => $street,
				'street_address_billing2'    => $street2,
				'town_address_billing'       => $town,
				'postal_code_billing'        => $postal_code,
				'phone_billing'              => $phone,
				'email_billing'              => $email,
			);

			$user_id     = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$new_history = get_user_meta($user_id, 'all_billing_address', true);
			if (!empty($new_history)) {
				$new_history1 = $new_history;
			} else {
				$new_history1 = array();
			}
			$arr1 = array();
			$arr1 = array_merge($new_history1, $new);
			update_user_meta($user_id, 'all_billing_address', $arr1);
		}

		if (isset($_POST['koala_multi_country_state_add_billing_front'])) {
			$country    = isset($_POST['koala_multi_country_state_add_billing_front']) ? sanitize_text_field($_POST['koala_multi_country_state_add_billing_front']) : '';
			$countr_obj = new WC_Countries();
			$a          = $countr_obj->get_states($country);
			?>
			<?php
			if (!empty($a)) {
				?>
				<label class="mylabel">State<span class="required">*</span></label><br>
				<select name="add_billing_state">
					<?php
					foreach ($a as $value) {
						?>
						<option>
							<?php
							echo esc_html__($value);
							?>
						</option>
						<?php
					}
					?>
				</select>
				<?php
			} else {
				?>
				<label class="mylabel"><?php esc_html_e('County (optional)', 'koala-multiple-customer-addresses'); ?></label><br>
				<input type="Text" name="get_input_state_billing">
				<?php
			}
			die();
		}

		if (isset($_POST['koala_multi_country_state_edit_billing_privious'])) {
			$country = isset($_POST['koala_multi_country_state_edit_billing_privious']) ? sanitize_text_field($_POST['koala_multi_country_state_edit_billing_privious']) : '';
			$user_id = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$state_name;
			$country_name;
			$shipping_privious_state = get_user_meta($user_id, 'all_billing_address', true);
			foreach ($shipping_privious_state as $key => $value) {
				if ($key == $country) {
					$country_name = $shipping_privious_state[ $key ]['country_billing'];
					$state_name   = $shipping_privious_state[ $key ]['country_state'];
				}
			}
			$countr_obj = new WC_Countries();
			$a          = $countr_obj->get_states($country_name);
			?>

			<?php
			$b = 0;
			foreach ($a as $value) {
				if ($value == $state_name) {
					$b++;
				}
			}

			if ($b > 0) {
				?>
				<label class="mylabel"><?php esc_html_e('State', 'koala-multiple-customer-addresses'); ?><span class="required">*</span></label><br>
				<select name="country_state_billing_edit">
					<?php
					foreach ($a as $key => $value) {
						if ($value == $state_name) {
							?>

							<option selected="selected">
								<?php
								echo esc_html__($value);
								?>
							</option>
							<?php

						} else {
							?>
							<option>
								<?php
								echo esc_html__($value);
								?>
							</option>
							<?php
						}
					}
					?>
				</select>
				<?php
			} else {
				?>
				<label class="mylabel"><?php esc_html_e('County (optional)', 'koala-multiple-customer-addresses'); ?></label><br>
				<input type="text" name="state_saved_name_billing_front" value="<?php echo esc_html($state_name); ?>">
				<?php
			}
			die();
		}

		if (isset($_POST['koala_multi_country_state_edit_billing'])) {
			$country    = isset($_POST['koala_multi_country_state_edit_billing']) ? sanitize_text_field($_POST['koala_multi_country_state_edit_billing']) : '';
			$countr_obj = new WC_Countries();
			$a          = $countr_obj->get_states($country);
			?>
			<?php
			if (!empty($a)) {
				?>
				<label class="mylabel"><?php esc_html_e('State', 'koala-multiple-customer-addresses'); ?><span class="required">*</span></label><br>
				<select name="country_state_billing_edit">
					<?php
					foreach ($a as $value) {
						?>
						<option>
							<?php
							echo esc_html__($value);
							?>
						</option>
						<?php
					}
					?>

				</select>
				<?php
			} else {
				?>
				<label class="mylabel"><?php esc_html_e('County (optional)', 'koala-multiple-customer-addresses'); ?></label><br>
				<input type="Text" name="get_input_state_billing_edit">
				<?php
			}
			die();
		}

		if (isset($_POST['cart_shipping_form'])) {

			$id          = isset($_POST['idname']) ? sanitize_text_field($_POST['idname']) : '';
			$fname       = isset($_POST['fname']) ? sanitize_text_field($_POST['fname']) : '';
			$lname       = isset($_POST['lname']) ? sanitize_text_field($_POST['lname']) : '';
			$cname       = isset($_POST['cname']) ? sanitize_text_field($_POST['cname']) : '';
			$country     = isset($_POST['country']) ? sanitize_text_field($_POST['country']) : '';
			$state       = isset($_POST['state']) ? sanitize_text_field($_POST['state']) : '';
			$street      = isset($_POST['street1']) ? sanitize_text_field($_POST['street1']) : '';
			$street2     = isset($_POST['street2']) ? sanitize_text_field($_POST['street2']) : '';
			$town        = isset($_POST['town']) ? sanitize_text_field($_POST['town']) : '';
			$postal_code = isset($_POST['postal']) ? sanitize_text_field($_POST['postal']) : '';
			if (isset($_POST['phone'])) {
				$phone = isset($_POST['phone']) ? sanitize_text_field($_POST['phone']) : '';
			} else {
				$phone = '';
			}
			if (isset($_POST['email'])) {

				$email = isset($_POST['email']) ? sanitize_text_field($_POST['email']) : '';
			} else {
				$email = '';
			}

			if (isset($_POST['idname'])) {

				$idname = isset($_POST['idname']) ? sanitize_text_field($_POST['idname']) : '';
			} else {
				$idname = $fname . ' ' . $lname . $street . $country . $town;
			}
			$new[] = array(
				'address_identifier_shipping' => $idname,
				'first_name_shipping'      => $fname,
				'last_name_shipping'       => $lname,
				'copmany_name_shipping'    => $cname,
				'country_name_shipping'    => $country,
				'country_state_shipping'   => $state,
				'street_address_shipping'  => $street,
				'street_address_shipping2' => $street2,
				'town_address_shipping'    => $town,
				'pin_code_shipping'        => $postal_code,
				'phone_shipping'           => $phone,
				'email_shipping'           => $email,
			);

			$user_id     = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$new_history = get_user_meta($user_id, 'all_shipping_address', true);
			if (!empty($new_history)) {
				$new_history1 = $new_history;
			} else {
				$new_history1 = array();
			}
			$arr1 = array();
			$arr1 = array_merge($new_history1, $new);
			update_user_meta($user_id, 'all_shipping_address', $arr1);
		}

		if (isset($_POST['koala_multi_country_state_add_shipping_front'])) {
			$country    = isset($_POST['koala_multi_country_state_add_shipping_front']) ? sanitize_text_field($_POST['koala_multi_country_state_add_shipping_front']) : '';
			$countr_obj = new WC_Countries();
			$a          = $countr_obj->get_states($country);
			?>
			<?php
			if (!empty($a)) {

				?>
				<label class="mylabel"><?php esc_html_e('State', 'koala-multiple-customer-addresses'); ?><span class="required">*</span></label><br>
				<select name="add_shipping_state">
					<?php
					foreach ($a as $value) {
						?>
						<option>
							<?php
							echo esc_html__($value);
							?>
						</option>
						<?php
					}
					?>

				</select>
				<?php
			} else {
				?>
				<label class="mylabel"><?php esc_html_e('County (optional)', 'koala-multiple-customer-addresses'); ?></label><br>
				<input type="Text" name="get_input_state_shipping">
				<?php
			}
			die();
		}

		if (isset($_POST['koala_multi_country_state_edit_shipping_privious'])) {
			$country = isset($_POST['koala_multi_country_state_edit_shipping_privious']) ? sanitize_text_field($_POST['koala_multi_country_state_edit_shipping_privious']) : '';
			$user_id = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$state_name;
			$country_name;
			$shipping_privious_state = get_user_meta($user_id, 'all_shipping_address', true);
			foreach ($shipping_privious_state as $key => $value) {
				if ($key == $country) {
					$country_name = $shipping_privious_state[ $key ]['country_name_shipping'];
					$state_name   = $shipping_privious_state[ $key ]['country_state_shipping'];
				}
			}
			$countr_obj = new WC_Countries();
			$a          = $countr_obj->get_states($country_name);
			?>
			<?php
			$b = 0;
			foreach ($a as $value) {
				if ($value == $state_name) {
					$b++;
				}
			}
			if ($b > 0) {
				?>
				<label class="mylabel"><?php esc_html_e('State', 'koala-multiple-customer-addresses'); ?><span class="required">*</span></label><br>
				<select name="country_state_shipping_edit">
					<?php
					foreach ($a as $key => $value) {
						if ($value == $state_name) {
							?>

							<option selected="selected">
								<?php
								echo esc_html__($value);
								?>
							</option>
							<?php

						} else {
							?>
							<option>
								<?php
								echo esc_html__($value);
								?>
							</option>
							<?php
						}
					}
					?>
				</select>
				<?php
			} else {
				?>
				<label class="mylabel"><?php esc_html_e('County (optional)', 'koala-multiple-customer-addresses'); ?></label><br>
				<input type="text" name="state_saved_name" value="<?php echo esc_html($state_name); ?>">
				<?php
			}
			die();
		}

		if (isset($_POST['koala_multi_country_state_edit_shipping'])) {
			$country    = isset($_POST['koala_multi_country_state_edit_shipping']) ? sanitize_text_field($_POST['koala_multi_country_state_edit_shipping']) : '';
			$countr_obj = new WC_Countries();
			$a          = $countr_obj->get_states($country);
			?>
			<?php
			if (!empty($a)) {
				?>
				<label class="mylabel"><?php esc_html_e('State', 'koala-multiple-customer-addresses'); ?><span class="required">*</span></label><br>
				<select name="country_state_shipping_edit">
					<?php
					foreach ($a as $value) {
						?>
						<option>
							<?php
							echo esc_html__($value);
							?>
						</option>
						<?php
					}
					?>

				</select>
				<?php
			} else {
				?>
				<label class="mylabel"><?php esc_html_e('County (optional)', 'koala-multiple-customer-addresses'); ?></label><br>
				<input type="Text" name="get_input_state_shipping_edit">
				<?php
			}
			die();
		}

		if (isset($_POST['address_id_shipping_front'])) {
			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta($user_id, 'all_shipping_address', true);
			$id           = isset($_POST['address_id_shipping_front']) ? sanitize_text_field($_POST['address_id_shipping_front']) : '';
			foreach ($all_shipping as $key => $value) {
				if ($key == $id) {
					$idname  = $all_shipping[ $key ]['address_identifier_shipping'];
					$fname   = $all_shipping[ $key ]['first_name_shipping'];
					$lname   = $all_shipping[ $key ]['last_name_shipping'];
					$cname   = $all_shipping[ $key ]['copmany_name_shipping'];
					$country = $all_shipping[ $key ]['country_name_shipping'];
					$state   = $all_shipping[ $key ]['country_state_shipping'];
					$street  = $all_shipping[ $key ]['street_address_shipping'];
					$street2 = $all_shipping[ $key ]['street_address_shipping2'];
					$town    = $all_shipping[ $key ]['town_address_shipping'];
					$pin     = $all_shipping[ $key ]['pin_code_shipping'];
					$phone   = $all_shipping[ $key ]['phone_shipping'];
					$email   = $all_shipping[ $key ]['email_shipping'];
				}
			}
			$countr_obj = new WC_Countries();
			$state_code = 'abc';
			$a          = $countr_obj->get_states($country);
			if (!empty($a)) {
				foreach ($a as $key => $value) {
					if ($value == $state) {
						$state_code = $key;
					}
				}
				$state = $state_code;
			}
			update_user_meta($user_id, 'shipping_first_name', $fname);
			update_user_meta($user_id, 'shipping_last_name', $lname);
			update_user_meta($user_id, 'shipping_company', $cname);
			update_user_meta($user_id, 'shipping_country', $country);
			update_user_meta($user_id, 'shipping_state', $state);
			update_user_meta($user_id, 'shipping_city', $town);
			update_user_meta($user_id, 'shipping_postcode', $pin);
			update_user_meta($user_id, 'shipping_address_1', $street);
			update_user_meta($user_id, 'shipping_address_2', $street2);
			update_user_meta($user_id, 'shipping_email', $email);
			update_user_meta($user_id, 'shipping_phone', $phone);
		}

		if (isset($_POST['address_id_billing_front'])) {
			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta($user_id, 'all_billing_address', true);
			$id           = isset($_POST['address_id_billing_front']) ? sanitize_text_field($_POST['address_id_billing_front']) : '';
			foreach ($all_shipping as $key => $value) {
				if ($key == $id) {
					$idname  = $all_shipping[ $key ]['address_identifier_billing'];
					$fname   = $all_shipping[ $key ]['first_name_billing'];
					$lname   = $all_shipping[ $key ]['last_name_billing'];
					$cname   = $all_shipping[ $key ]['copmany_name_billing'];
					$country = $all_shipping[ $key ]['country_billing'];
					$state   = $all_shipping[ $key ]['country_state'];
					$street  = $all_shipping[ $key ]['street_address_billing'];
					$street2 = $all_shipping[ $key ]['street_address_billing2'];
					$town    = $all_shipping[ $key ]['town_address_billing'];
					$postal  = $all_shipping[ $key ]['postal_code_billing'];
					$phone   = $all_shipping[ $key ]['phone_billing'];
					$email   = $all_shipping[ $key ]['email_billing'];
				}
			}

			$countr_obj = new WC_Countries();
			$state_code = 'abc';

			$a = $countr_obj->get_states($country);
			if (!empty($a)) {
				foreach ($a as $key => $value) {
					if ($value == $state) {
						$state_code = $key;
					}
				}
				$state = $state_code;
			}

			update_user_meta($user_id, 'billing_first_name', $fname);
			update_user_meta($user_id, 'billing_last_name', $lname);
			update_user_meta($user_id, 'billing_company', $cname);
			update_user_meta($user_id, 'billing_country', $country);
			update_user_meta($user_id, 'billing_state', $state);
			update_user_meta($user_id, 'billing_city', $town);
			update_user_meta($user_id, 'billing_postcode', $postal);
			update_user_meta($user_id, 'billing_address_1', $street);
			update_user_meta($user_id, 'billing_address_2', $street2);
			update_user_meta($user_id, 'billing_email', $email);
			update_user_meta($user_id, 'billing_phone', $phone);
		}
	}

	public function kawmsa_update_addresses() {

		$nonce = isset($_POST['nonce']) ? sanitize_text_field( $_POST['nonce'] ) : 0;
		if ( ! wp_verify_nonce($nonce, 'multi_address_nonce_admin') ) {
			wp_die(esc_html__('Security Violated!', 'koala-multiple-customer-addresses'));
		}

		if (isset($_POST['address_id_cart'])) {
			$address_id   = isset($_POST['address_id_cart']) ? sanitize_text_field($_POST['address_id_cart']) : '';
			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta(get_current_user_id(), 'all_billing_address', true);
			
			foreach ($all_shipping as $key => $value) {
				if ($key == $address_id) {
					$idname  = $all_shipping[ $key ]['address_identifier_billing'];
					$fname   = $all_shipping[ $key ]['first_name_billing'];
					$lname   = $all_shipping[ $key ]['last_name_billing'];
					$cname   = $all_shipping[ $key ]['copmany_name_billing'];
					$country = $all_shipping[ $key ]['country_billing'];
					$state   = $all_shipping[ $key ]['country_state'];
					$street  = $all_shipping[ $key ]['street_address_billing'];
					$street2 = $all_shipping[ $key ]['street_address_billing2'];
					$town    = $all_shipping[ $key ]['town_address_billing'];
					$postal  = $all_shipping[ $key ]['postal_code_billing'];
					$phone   = $all_shipping[ $key ]['phone_billing'];
					$email   = $all_shipping[ $key ]['email_billing'];
				}
			}

			$countr_obj = new WC_Countries();
			$state_name = $state;
			$state_code = 'abc';
			$a          = $countr_obj->get_states($country);
			if (!empty($a)) {
				foreach ($a as $key => $value) {
					if ($value == $state) {
						$state_code = $key;
					}
				}
				$state = $state_code;
			}
			$country_full_name;
			$countries = $countr_obj->__get('countries');
			foreach ($countries as $key => $value) {
				if ($key == $country) {
					$country_full_name = $value;
				}
			}
			wp_send_json(
				array(
					'idname'            => $idname,
					'fname'             => $fname,
					'lname'             => $lname,
					'cname'             => $cname,
					'country'           => $country,
					'state'             => $state,
					'street'            => $street,
					'street2'           => $street2,
					'town'              => $town,
					'postal'            => $postal,
					'phone'             => $phone,
					'email'             => $email,
					'country_full_name' => $country_full_name,
					'state_full_name'   => $state_name,
				)
			);
			wp_die();
		}

		if (isset($_POST['address_id_cart_shipping'])) {
			$address_id = isset($_POST['address_id_cart_shipping']) ? sanitize_text_field($_POST['address_id_cart_shipping']) : '';

			$user_id = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';

			$all_shipping = get_user_meta(get_current_user_id(), 'all_shipping_address', true);
		
			foreach ($all_shipping as $key => $value) {
				if ($key == $address_id) {
					$idname  = $all_shipping[ $key ]['address_identifier_shipping'];
					$fname   = $all_shipping[ $key ]['first_name_shipping'];
					$lname   = $all_shipping[ $key ]['last_name_shipping'];
					$cname   = $all_shipping[ $key ]['copmany_name_shipping'];
					$country = $all_shipping[ $key ]['country_name_shipping'];
					$state   = $all_shipping[ $key ]['country_state_shipping'];
					$street  = $all_shipping[ $key ]['street_address_shipping'];
					$street2 = $all_shipping[ $key ]['street_address_shipping2'];
					$town    = $all_shipping[ $key ]['town_address_shipping'];
					$pin     = $all_shipping[ $key ]['pin_code_shipping'];
					$phone   = $all_shipping[ $key ]['phone_shipping'];
					$email   = $all_shipping[ $key ]['email_shipping'];
				}
			}
			$countr_obj = new WC_Countries();
			$state_name = $state;
			$state_code = 'abc';
			$a          = $countr_obj->get_states($country);
			if (!empty($a)) {
				foreach ($a as $key => $value) {
					if ($value == $state) {
						$state_code = $key;
					}
				}
				$state = $state_code;
			}
			$country_full_name;
			$countries = $countr_obj->__get('countries');
			foreach ($countries as $key => $value) {
				if ($key == $country) {
					$country_full_name = $value;
				}
			}
			wp_send_json(
				array(
					'idname'            => $idname,
					'fname'             => $fname,
					'lname'             => $lname,
					'cname'             => $cname,
					'country'           => $country,
					'state'             => $state,
					'street'            => $street,
					'street2'           => $street2,
					'town'              => $town,
					'postal'            => $pin,
					'phone'             => $phone,
					'email'             => $email,
					'country_full_name' => $country_full_name,
					'state_full_name'   => $state_name,
				)
			);
			wp_die();
		}
	}
	public function wmsa_address_data_ajax() {

		$nonce = isset($_POST['nonce']) ? sanitize_text_field( $_POST['nonce'] ) : 0;
		if ( ! wp_verify_nonce($nonce, 'multi_address_nonce_admin') ) {
			wp_die(esc_html__('Security Violated!', 'koala-multiple-customer-addresses'));
		}

		if (isset($_POST['billing_form_submit_front'])) {
			$user_id     = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$fname       = isset($_POST['first_name_billing']) ? sanitize_text_field($_POST['first_name_billing']) : '';
			$lname       = isset($_POST['last_name_billing']) ? sanitize_text_field($_POST['last_name_billing']) : '';
			$cname       = isset($_POST['copmany_name_billing']) ? sanitize_text_field($_POST['copmany_name_billing']) : '';
			$country     = isset($_POST['country_name_billing']) ? sanitize_text_field($_POST['country_name_billing']) : '';
			$state       = isset($_POST['add_billing_state']) ? sanitize_text_field($_POST['add_billing_state']) : '';
			$street      = isset($_POST['st_address_billing']) ? sanitize_text_field($_POST['st_address_billing']) : '';
			$street2     = isset($_POST['st_address_billing2']) ? sanitize_text_field($_POST['st_address_billing2']) : '';
			$town        = isset($_POST['town_address_billing']) ? sanitize_text_field($_POST['town_address_billing']) : '';
			$postal_code = isset($_POST['postal_code_billing']) ? sanitize_text_field($_POST['postal_code_billing']) : '';
			$phone       = isset($_POST['phone_billing']) ? sanitize_text_field($_POST['phone_billing']) : '';
			$email       = isset($_POST['email_billing']) ? sanitize_text_field($_POST['email_billing']) : '';
			if (isset($_POST['identifier_name_billing'])) {
				$idname = isset($_POST['identifier_name_billing']) ? sanitize_text_field($_POST['identifier_name_billing']) : '';
			} else {
				$idname = $fname . $lname . $street . $country . $town;
			}
			$new         = array();
			$new_history = array();
			$new[]       = array(
				'address_identifier_billing' => $idname,
				'first_name_billing'         => $fname,
				'last_name_billing'          => $lname,
				'copmany_name_billing'       => $cname,
				'country_billing'            => $country,
				'country_state'              => $state,
				'street_address_billing'     => $street,
				'street_address_billing2'    => $street2,
				'town_address_billing'       => $town,
				'postal_code_billing'        => $postal_code,
				'phone_billing'              => $phone,
				'email_billing'              => $email,
			);
			$new_history = get_user_meta($user_id, 'all_billing_address', true);
			if (!empty($new_history)) {
				$new_history1 = $new_history;
			} else {
				$new_history1 = array();
			}
			$arr1 = array();
			$arr1 = array_merge($new_history1, $new);
			update_user_meta($user_id, 'all_billing_address', $arr1);
		}
		if (isset($_POST['duplicate_billing_front'])) {
			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta($user_id, 'all_billing_address', true);
			$a1           = isset($_POST['duplicate_billing_front']) ? sanitize_text_field($_POST['duplicate_billing_front']) : '';
			$idname       = $all_shipping[ $a1 ]['address_identifier_billing'];
			$fname        = $all_shipping[ $a1 ]['first_name_billing'];
			$lname        = $all_shipping[ $a1 ]['last_name_billing'];
			$cname        = $all_shipping[ $a1 ]['copmany_name_billing'];
			$country      = $all_shipping[ $a1 ]['country_billing'];
			$state        = $all_shipping[ $a1 ]['country_state'];
			$street       = $all_shipping[ $a1 ]['street_address_billing'];
			$street2      = $all_shipping[ $a1 ]['street_address_billing2'];
			$town         = $all_shipping[ $a1 ]['town_address_billing'];
			$postal_code  = $all_shipping[ $a1 ]['postal_code_billing'];
			$phone        = $all_shipping[ $a1 ]['phone_billing'];
			$email        = $all_shipping[ $a1 ]['email_billing'];
			$new          = array();
			$new_history  = array();
			$new[]        = array(
				'address_identifier_billing' => $idname,
				'first_name_billing'         => $fname,
				'last_name_billing'          => $lname,
				'copmany_name_billing'       => $cname,
				'country_billing'            => $country,
				'country_state'              => $state,
				'street_address_billing'     => $street,
				'street_address_billing2'    => $street2,
				'town_address_billing'       => $town,
				'postal_code_billing'        => $postal_code,
				'phone_billing'              => $phone,
				'email_billing'              => $email,
			);
			$new_history  = get_user_meta($user_id, 'all_billing_address', true);
			if (!empty($new_history)) {
				$new_history1 = $new_history;
			} else {
				$new_history1 = array();
			}
			$arr1 = array();
			$arr1 = array_merge($new_history1, $new);
			update_user_meta($user_id, 'all_billing_address', $arr1);
		}
		if (isset($_POST['delete_address_billing_front'])) {
			$user_id     = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_billing = get_user_meta($user_id, 'all_billing_address', true);
			$radio_state = get_user_meta($user_id, 'default_billing_meta', true);
			$a1          = isset($_POST['delete_address_billing_front']) ? sanitize_text_field($_POST['delete_address_billing_front']) : '';
			$b           = 'a';
			if ($a1 == $radio_state) {
				update_user_meta($user_id, 'default_billing_meta', $b);
			}
			unset($all_billing[ $a1 ]);

			update_user_meta($user_id, 'all_billing_address', $all_billing);
		}
		if (isset($_POST['billing_form_edit_front'])) {

			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta($user_id, 'all_billing_address', true);
			$id           = isset($_POST['edit_id_billing']) ? sanitize_text_field($_POST['edit_id_billing']) : '';
			$a            = 0;
			update_user_meta($user_id, 'all_billing_address', $a);
			foreach ($all_shipping as $key => $value) {
				if ($key != $id) {
					$idname      = $all_shipping[ $key ]['address_identifier_billing'];
					$fname       = $all_shipping[ $key ]['first_name_billing'];
					$lname       = $all_shipping[ $key ]['last_name_billing'];
					$cname       = $all_shipping[ $key ]['copmany_name_billing'];
					$country     = $all_shipping[ $key ]['country_billing'];
					$state       = $all_shipping[ $key ]['country_state'];
					$street      = $all_shipping[ $key ]['street_address_billing'];
					$street2     = $all_shipping[ $key ]['street_address_billing2'];
					$town        = $all_shipping[ $key ]['town_address_billing'];
					$postal      = $all_shipping[ $key ]['postal_code_billing'];
					$phone       = $all_shipping[ $key ]['phone_billing'];
					$email       = $all_shipping[ $key ]['email_billing'];
					$new         = array();
					$new_history = array();
					$new[ $key ]   = array(
						'address_identifier_billing' => $idname,
						'first_name_billing'         => $fname,
						'last_name_billing'          => $lname,
						'copmany_name_billing'       => $cname,
						'country_billing'            => $country,
						'country_state'              => $state,
						'street_address_billing'     => $street,
						'street_address_billing2'    => $street2,
						'town_address_billing'       => $town,
						'postal_code_billing'        => $postal,
						'phone_billing'              => $phone,
						'email_billing'              => $email,
					);
					$new_history = get_user_meta($user_id, 'all_billing_address', true);
					if (!empty($new_history)) {
						$new_history1 = $new_history;
					} else {
						$new_history1 = array();
					}
					$arr1 = array();
					$arr1 = array_replace_recursive($new_history1, $new);
					update_user_meta($user_id, 'all_billing_address', $arr1);
				} else {
					$fname   = isset($_POST['first_name_billing_edit']) ? sanitize_text_field($_POST['first_name_billing_edit']) : '';
					$lname   = isset($_POST['last_name_billing_edit']) ? sanitize_text_field($_POST['last_name_billing_edit']) : '';
					$cname   = isset($_POST['copmany_name_billing_edit']) ? sanitize_text_field($_POST['copmany_name_billing_edit']) : '';
					$country = isset($_POST['country_name_billing_edit']) ? sanitize_text_field($_POST['country_name_billing_edit']) : '';

					$state = isset($_POST['add_billing_state_edit']) ? sanitize_text_field($_POST['add_billing_state_edit']) : '';

					$street  = isset($_POST['st_address_billing_edit']) ? sanitize_text_field($_POST['st_address_billing_edit']) : '';
					$street2 = isset($_POST['st_address_billing_edit2']) ? sanitize_text_field($_POST['st_address_billing_edit2']) : '';
					$town    = isset($_POST['town_address_billing_edit']) ? sanitize_text_field($_POST['town_address_billing_edit']) : '';
					$postal  = isset($_POST['postal_code_billing_edit']) ? sanitize_text_field($_POST['postal_code_billing_edit']) : '';
					$phone   = isset($_POST['phone_billing_edit']) ? sanitize_text_field($_POST['phone_billing_edit']) : '';
					$email   = isset($_POST['email_billing_edit']) ? sanitize_text_field($_POST['email_billing_edit']) : '';

					$idname = isset($_POST['identifier_name_billing_edit']) ? sanitize_text_field($_POST['identifier_name_billing_edit']) : '';

					$new         = array();
					$new_history = array();
					$new[ $id ]    = array(
						'address_identifier_billing' => $idname,
						'first_name_billing'         => $fname,
						'last_name_billing'          => $lname,
						'copmany_name_billing'       => $cname,
						'country_billing'            => $country,
						'country_state'              => $state,
						'street_address_billing'     => $street,
						'street_address_billing2'    => $street2,
						'town_address_billing'       => $town,
						'postal_code_billing'        => $postal,
						'phone_billing'              => $phone,
						'email_billing'              => $email,
					);
					$new_history = get_user_meta($user_id, 'all_billing_address', true);
					if (!empty($new_history)) {
						$new_history1 = $new_history;
					} else {
						$new_history1 = array();
					}
					$arr1 = array();
					$arr1 = array_replace_recursive($new_history1, $new);
					update_user_meta($user_id, 'all_billing_address', $arr1);
				}
			}
		}
		if (isset($_POST['shipping_form_submit_front'])) {
			$user_id     = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$fname       = isset($_POST['first_name_shipping']) ? sanitize_text_field($_POST['first_name_shipping']) : '';
			$lname       = isset($_POST['last_name_shipping']) ? sanitize_text_field($_POST['last_name_shipping']) : '';
			$cname       = isset($_POST['copmany_name_shipping']) ? sanitize_text_field($_POST['copmany_name_shipping']) : '';
			$country     = isset($_POST['country_name_shipping']) ? sanitize_text_field($_POST['country_name_shipping']) : '';
			$state       = isset($_POST['add_shipping_state']) ? sanitize_text_field($_POST['add_shipping_state']) : '';
			$street      = isset($_POST['st_address_shipping']) ? sanitize_text_field($_POST['st_address_shipping']) : '';
			$street2     = isset($_POST['st_address_shipping2']) ? sanitize_text_field($_POST['st_address_shipping2']) : '';
			$town        = isset($_POST['town_address_shipping']) ? sanitize_text_field($_POST['town_address_shipping']) : '';
			$pin         = isset($_POST['pin_code_shipping']) ? sanitize_text_field($_POST['pin_code_shipping']) : '';
			$idname      = isset($_POST['identifier_name_shipping']) ? sanitize_text_field($_POST['identifier_name_shipping']) : '';
			$phone       = isset($_POST['phone_shipping']) ? sanitize_text_field($_POST['phone_shipping']) : '';
			$email       = isset($_POST['email_shipping']) ? sanitize_text_field($_POST['email_shipping']) : '';
			$new         = array();
			$new_history = array();
			$new[]       = array(
				'address_identifier_shipping' => $idname,
				'first_name_shipping'         => $fname,
				'last_name_shipping'          => $lname,
				'copmany_name_shipping'       => $cname,
				'country_name_shipping'       => $country,
				'country_state_shipping'      => $state,
				'street_address_shipping'     => $street,
				'street_address_shipping2'    => $street2,
				'town_address_shipping'       => $town,
				'pin_code_shipping'           => $pin,
				'phone_shipping'              => $phone,
				'email_shipping'              => $email,
			);
			$new_history = get_user_meta($user_id, 'all_shipping_address', true);
			if (!empty($new_history)) {
				$new_history1 = $new_history;
			} else {
				$new_history1 = array();
			}
			$arr1 = array();
			$arr1 = array_merge($new_history1, $new);
			update_user_meta($user_id, 'all_shipping_address', $arr1);
		}
		if (isset($_POST['duplicate_shipping_front'])) {
			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta($user_id, 'all_shipping_address', true);
			$a1           = isset($_POST['duplicate_shipping_front']) ? sanitize_text_field($_POST['duplicate_shipping_front']) : '';
			$idname       = $all_shipping[ $a1 ]['address_identifier_shipping'];
			$fname        = $all_shipping[ $a1 ]['first_name_shipping'];
			$lname        = $all_shipping[ $a1 ]['last_name_shipping'];
			$cname        = $all_shipping[ $a1 ]['copmany_name_shipping'];
			$country      = $all_shipping[ $a1 ]['country_name_shipping'];
			$state        = $all_shipping[ $a1 ]['country_state_shipping'];
			$street       = $all_shipping[ $a1 ]['street_address_shipping'];
			$street2      = $all_shipping[ $a1 ]['street_address_shipping2'];
			$town         = $all_shipping[ $a1 ]['town_address_shipping'];
			$pin          = $all_shipping[ $a1 ]['pin_code_shipping'];
			$phone        = $all_shipping[ $a1 ]['phone_shipping'];
			$email        = $all_shipping[ $a1 ]['email_shipping'];
			$new          = array();
			$new_history  = array();
			$new[]        = array(
				'address_identifier_shipping' => $idname,
				'first_name_shipping'         => $fname,
				'last_name_shipping'          => $lname,
				'copmany_name_shipping'       => $cname,
				'country_name_shipping'       => $country,
				'country_state_shipping'      => $state,
				'street_address_shipping'     => $street,
				'street_address_shipping2'    => $street2,
				'town_address_shipping'       => $town,
				'pin_code_shipping'           => $pin,
				'phone_shipping'              => $phone,
				'email_shipping'              => $email,
			);
			$new_history  = get_user_meta($user_id, 'all_shipping_address', true);
			if (!empty($new_history)) {
				$new_history1 = $new_history;
			} else {
				$new_history1 = array();
			}
			$arr1 = array();
			$arr1 = array_merge($new_history1, $new);
			update_user_meta($user_id, 'all_shipping_address', $arr1);
			wp_die();
		}
		if (isset($_POST['delete_address_shipping_front'])) {
			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta($user_id, 'all_shipping_address', true);

			$a1 = isset($_POST['delete_address_shipping_front']) ? sanitize_text_field($_POST['delete_address_shipping_front']) : '';

			$radio_state_shipping = get_user_meta($user_id, 'default_shipping_meta', true);
			$a                    = 'b';
			if ($a1 == $radio_state_shipping) {
				update_user_meta($user_id, 'default_shipping_meta', $a);
			}

			unset($all_shipping[ $a1 ]);

			update_user_meta($user_id, 'all_shipping_address', $all_shipping);
			wp_die();
		}

		if (isset($_POST['shipping_form_edit_front'])) {
			$user_id      = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
			$all_shipping = get_user_meta($user_id, 'all_shipping_address', true);
			$id           = isset($_POST['edit_id_shipping']) ? sanitize_text_field($_POST['edit_id_shipping']) : '';
			$a            = 0;
			update_user_meta($user_id, 'all_shipping_address', $a);
			foreach ($all_shipping as $key => $value) {
				if ($key != $id) {
					$idname      = $all_shipping[ $key ]['address_identifier_shipping'];
					$fname       = $all_shipping[ $key ]['first_name_shipping'];
					$lname       = $all_shipping[ $key ]['last_name_shipping'];
					$cname       = $all_shipping[ $key ]['copmany_name_shipping'];
					$country     = $all_shipping[ $key ]['country_name_shipping'];
					$state       = $all_shipping[ $key ]['country_state_shipping'];
					$street      = $all_shipping[ $key ]['street_address_shipping'];
					$street2     = $all_shipping[ $key ]['street_address_shipping2'];
					$town        = $all_shipping[ $key ]['town_address_shipping'];
					$pin         = $all_shipping[ $key ]['pin_code_shipping'];
					$phone       = $all_shipping[ $key ]['phone_shipping'];
					$email       = $all_shipping[ $key ]['email_shipping'];
					$new         = array();
					$new_history = array();
					$new[ $key ]   = array(
						'address_identifier_shipping' => $idname,
						'first_name_shipping'         => $fname,
						'last_name_shipping'          => $lname,
						'copmany_name_shipping'       => $cname,
						'country_name_shipping'       => $country,
						'country_state_shipping'      => $state,
						'street_address_shipping'     => $street,
						'street_address_shipping2'    => $street2,
						'town_address_shipping'       => $town,
						'pin_code_shipping'           => $pin,
						'phone_shipping'              => $phone,
						'email_shipping'              => $email,
					);
					$new_history = get_user_meta($user_id, 'all_shipping_address', true);
					if (!empty($new_history)) {
						$new_history1 = $new_history;
					} else {
						$new_history1 = array();
					}
					$arr1 = array();
					$arr1 = array_replace_recursive($new_history1, $new);
					update_user_meta($user_id, 'all_shipping_address', $arr1);
				} else {
					$user_id = isset($_POST['user_id']) ? sanitize_text_field($_POST['user_id']) : '';
					$fname   = isset($_POST['first_name_shipping_edit']) ? sanitize_text_field($_POST['first_name_shipping_edit']) : '';
					$lname   = isset($_POST['last_name_shipping_edit']) ? sanitize_text_field($_POST['last_name_shipping_edit']) : '';
					$cname   = isset($_POST['copmany_name_shipping_edit']) ? sanitize_text_field($_POST['copmany_name_shipping_edit']) : '';

					$country = isset($_POST['country_name_shipping_edit']) ? sanitize_text_field($_POST['country_name_shipping_edit']) : '';

					$state = isset($_POST['add_shipping_state_edit']) ? sanitize_text_field($_POST['add_shipping_state_edit']) : '';

					$street = isset($_POST['st_address_shipping_edit']) ? sanitize_text_field($_POST['st_address_shipping_edit']) : '';

					$street2 = isset($_POST['st_address_shipping2_edit']) ? sanitize_text_field($_POST['st_address_shipping2_edit']) : '';

					$town = isset($_POST['town_address_shipping_edit']) ? sanitize_text_field($_POST['town_address_shipping_edit']) : '';
					$pin  = isset($_POST['pin_code_shipping_edit']) ? sanitize_text_field($_POST['pin_code_shipping_edit']) : '';

					$idname = isset($_POST['identifier_name_shipping_edit']) ? sanitize_text_field($_POST['identifier_name_shipping_edit']) : '';

					$add_shipping_phone = get_option('add_shipping_phone_option');
					if ('1' === $add_shipping_phone) {
						$phone = isset($_POST['phone_shipping_edit']) ? sanitize_text_field($_POST['phone_shipping_edit']) : '';
					} else {
						$phone = '';
					}

					$add_shipping_email = get_option('add_shipping_email_option');
					if ('1' === $add_shipping_email) {
						$email = isset($_POST['email_shipping_edit']) ? sanitize_text_field($_POST['email_shipping_edit']) : '';
					} else {
						$email = '';
					}
					$new         = array();
					$new_history = array();
					$new[ $id ]    = array(
						'address_identifier_shipping' => $idname,
						'first_name_shipping'         => $fname,
						'last_name_shipping'          => $lname,
						'copmany_name_shipping'       => $cname,
						'country_name_shipping'       => $country,
						'country_state_shipping'      => $state,
						'street_address_shipping'     => $street,
						'street_address_shipping2'    => $street2,
						'town_address_shipping'       => $town,
						'pin_code_shipping'           => $pin,
						'phone_shipping'              => $phone,
						'email_shipping'              => $email,
					);
					$new_history = get_user_meta($user_id, 'all_shipping_address', true);
					if (!empty($new_history)) {
						$new_history1 = $new_history;
					} else {
						$new_history1 = array();
					}
					$arr1 = array();
					$arr1 = array_replace_recursive($new_history1, $new);
					update_user_meta($user_id, 'all_shipping_address', $arr1);
				}
			}
		}
	}
}

new Koala_WMSA_Ajax();
