<?php
add_settings_section(
	'billing',
	'',
	'billing_callback',
	'billing_settings'
);
function billing_callback() { }
add_settings_field(
	'enable_disable_billing',
	__( 'Disable billing multiple addresses ', 'general_option_multiple_address' ),
	'disable_billing_callback',
	'billing_settings',
	'billing'
);
register_setting(
	'billing-page',
	'enable_disable_billing'
);
add_settings_field(
	'max_num_billing',
	__( 'Max number of billing addresses ', 'general_option_multiple_address' ),
	'max_number_of_billing_callback',
	'billing_settings',
	'billing'
);
register_setting(
	'billing-page',
	'max_num_billing'
);
add_settings_field(
	'disable_user_add_del_billing',
	__( 'Disable user add/edit/delete billing addresses capabilities ', 'general_option_multiple_address' ),
	'disable_user_update_billing_cap_callback',
	'billing_settings',
	'billing'
);
register_setting(
	'billing-page',
	'disable_user_add_del_billing'
);
add_settings_field(
	'require_company_field_billing',
	__( 'Billing company name - enabled required ', 'general_option_multiple_address' ),
	'require_company_billing_name_callback',
	'billing_settings',
	'billing'
);
register_setting(
	'billing-page',
	'require_company_field_billing'
);
add_settings_field(
	'billing_title_key_field',
	__( 'Billing Button Text', 'general_option_multiple_address' ),
	'billing_button_title_callback',
	'billing_settings',
	'billing'
);
register_setting(
	'billing-page',
	'billing_title_key_field'
);
add_settings_field(
	'billing_checkout_heading',
	__( 'Billing Checkout page Heading', 'general_option_multiple_address' ),
	'billing_checkout_page_heading_callback',
	'billing_settings',
	'billing'
);
register_setting(
	'billing-page',
	'billing_checkout_heading'
);
add_settings_field(
	'billing_myaccount_heading',
	__( 'Billing myaccount page Heading', 'general_option_multiple_address' ),
	'billing_myaccount_page_heading_callback',
	'billing_settings',
	'billing'
);
register_setting(
	'billing-page',
	'billing_myaccount_heading'
);
add_settings_field(
	'hide_add_new_check_bill',
	__( 'Hide billing add new address tag(checkout)', 'general_option_multiple_address' ),
	'hide_add_new_check_bill_callback',
	'billing_settings',
	'billing'
);
register_setting(
	'billing-page',
	'hide_add_new_check_bill'
);

function disable_billing_callback() {
	$getval = get_option( 'enable_disable_billing' );

	?>
	
	<input type="checkbox" name="enable_disable_billing" id="enable_billing" value="1"<?php checked( $getval, '1' ); ?>><?php esc_html_e( 'Disable', 'koala-multiple-customer-addresses' ); ?> <br>
	<?php echo esc_html__( 'Disabled Multiple billing address', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function max_number_of_billing_callback() {
	 $max_addresses = get_option( 'max_num_billing' );
	if ( '' == $max_addresses ) {
		$max_addresses = '0';
	}
	?>
	<input type="number" min="0" name="max_num_billing" id="max_size" value="<?php echo esc_attr( $max_addresses ); ?>"><br>
	<?php echo esc_html__( 'Max no of billing addresses. Leave 0 for no limits.', 'koala-multiple-customer-addresses' ); ?>
	<?php
}

function disable_user_update_billing_cap_callback() {
	$diable_cap = get_option( 'disable_user_add_del_billing' );

	?>
	
	<input type="checkbox" name="disable_user_add_del_billing" id="disable_cap" value="1"<?php checked( $diable_cap, '1' ); ?>><?php esc_html_e( 'Disable', 'koala-multiple-customer-addresses' ); ?> <br>
	<?php echo esc_html__( 'Disable user to insert, delete and edit the existing billing addresses.', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function require_company_billing_name_callback() {
	$require_company_billing = get_option( 'require_company_field_billing' );

	?>
	<input type="checkbox" name="require_company_field_billing" id="require_company_billing" value="1"<?php checked( $require_company_billing, '1' ); ?>><?php esc_html_e( 'Enable', 'koala-multiple-customer-addresses' ); ?><br>
	<?php echo esc_html__( 'Make billing company field required', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function billing_button_title_callback() {
	 $billing_label = get_option( 'billing_title_key_field' );

	?>
	<input type="text" name="billing_title_key_field" id="billing_title_id" value="<?php echo esc_attr( $billing_label ); ?>"> <br>
	<?php echo esc_html__( 'Add custom text for billing button.', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function billing_checkout_page_heading_callback() {
	 $billing_checkout = get_option( 'billing_checkout_heading' );
	?>
	<input type="text" name="billing_checkout_heading" id="billing_checkout_heading_id" value="<?php echo esc_attr( $billing_checkout ); ?>"> <br>
	<?php echo esc_html__( 'Add custom text on checkout page(Billing detail).', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function billing_myaccount_page_heading_callback() {
	 $billing_myaccount = get_option( 'billing_myaccount_heading' );
	?>
	<input type="text" name="billing_myaccount_heading" id="billing_myaccount_heading_id" value="<?php echo esc_attr( $billing_myaccount ); ?>"> <br>
	<?php echo esc_html__( 'Add custom text on myaccount page(Billing detail).', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function hide_add_new_check_bill_callback() {
	$hide_add_new_check = get_option( 'hide_add_new_check_bill' );
	?>
	<input type="checkbox" name="hide_add_new_check_bill" id="hide_add_new_check_bill_id" value="1"<?php checked( $hide_add_new_check, '1' ); ?>><?php esc_html_e( 'Disable', 'koala-multiple-customer-addresses' ); ?><br>
	<?php echo esc_html__( 'Checkout page hide add billing addresses tag', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
