<?php

add_settings_section(
	'general',
	'',
	'general_callback',
	'general_settings'
);

add_settings_field(
	'disable_identifier_name',
	__( 'Disable Identifier / Name field ', 'general_option_multiple_address' ),
	'disable_identifier_callback',
	'general_settings',
	'general'
);
register_setting(
	'setting-page',
	'disable_identifier_name'
);



add_settings_field(
	'wmsa_user_role',
	__( 'User role based setting', 'general_option_multiple_address' ),
	'user_role_callback',
	'general_settings',
	'general'
);
register_setting(
	'setting-page',
	'wmsa_user_role'
);


add_settings_field(
	'address_title_tag_key_field ',
	__( 'My account page - Addresses title tag', 'general_option_multiple_address' ),
	'address_title_callback',
	'general_settings',
	'general'
);
register_setting(
	'setting-page',
	'address_title_tag_key_field'
);
add_settings_field(
	'default_address_key_field',
	__( 'Default address label', 'general_option_multiple_address' ),
	'default_address_label_callback',
	'general_settings',
	'general'
);
register_setting(
	'setting-page',
	'default_address_key_field'
);

add_settings_field(
	'default_select_key_field',
	__( 'Default select label', 'general_option_multiple_address' ),
	'default_select_label_callback',
	'general_settings',
	'general'
);
register_setting(
	'setting-page',
	'default_select_key_field'
);


add_settings_field(
	'custom_css_account_key_field',
	__( 'Custom CSS rules - My account page', 'general_option_multiple_address' ),
	'custom_css_myaccount_callback',
	'general_settings',
	'general'
);
register_setting(
	'setting-page',
	'custom_css_account_key_field'
);

add_settings_field(
	'custom_css_checkout_key_field',
	__( 'Custom CSS rules - Checkout page', 'general_option_multiple_address' ),
	'custom_css_checkout_callback',
	'general_settings',
	'general'
);


register_setting(
	'setting-page',
	'custom_css_checkout_key_field'
);

add_settings_field(
	'load_more_background_color_setting',
	__( 'Button color - My account 
page', 'general_option_multiple_address' ),
	'backgroud_color_add_address_callback',
	'general_settings',
	'general'
);


register_setting(
	'setting-page',
	'load_more_background_color_setting'
);

add_settings_field(
	'load_more_text_color_setting',
	__( 'Button text color - My account 
page', 'general_option_multiple_address' ),
	'text_color_add_address_callback',
	'general_settings',
	'general'
);


register_setting(
	'setting-page',
	'load_more_text_color_setting'
);
add_settings_field(
	'text_color_add_address_checkout',
	__( 'Button text color - Checkout page', 'general_option_multiple_address' ),
	'text_color_add_address_checkout_callback',
	'general_settings',
	'general'
);

register_setting(
	'setting-page',
	'text_color_add_address_checkout'
);


function general_callback() { }



function backgroud_color_add_address_callback() {
	?>
			<div class="ajax_scrole_fld_hide">
			<input type="color" id="favcolor" name="load_more_background_color_setting" value="<?php echo esc_attr( get_option( 'load_more_background_color_setting' ) ); ?>">	
			<br>
				<p><i>
					<?php esc_html_e( 'Background color for Add new address button.', 'infinite_scrole' ); ?>
				</i></p>
			</div>
		<?php
}

function text_color_add_address_callback() {

	?>
			<div class="ajax_scrole_fld_hide">
			<input type="color" id="favcolor" name="load_more_text_color_setting" value="<?php echo esc_attr( get_option( 'load_more_text_color_setting' ) ); ?>">
			<br>
				<p><i>
				<?php esc_html_e( 'Text color for Add new address button.', 'infinite_scrole' ); ?>
				</i></p>
			</div> 		
		<?php
}

function disable_identifier_callback() {
	$getidentifier = get_option( 'disable_identifier_name' );

	?>
	<input type="checkbox" name="disable_identifier_name" id="disable_identifier" value="1"<?php checked( $getidentifier, '1' ); ?>><?php esc_html_e( 'Disable', 'koala-multiple-customer-addresses' ); ?><br>
	<?php echo esc_html__( 'By default the user has to specify,"Address identifier" Disabling this field the address will be identified using user address data', 'koala-multiple-customer-addresses' ); ?>
	<?php
}






function user_role_callback() {
	$select_user_from_switch = get_option( 'wmsa_user_role' );
	?>

	<select id="select_user_from_switch" style="width: 300px;" name="wmsa_user_role[]" class="wmsa_select2"  multiple >
												<?php
												global $wp_roles;
												$switch_from_roles = $wp_roles->get_names();
												foreach ( $switch_from_roles as $key => $from_switch_role ) {
													?>
													<option value="<?php echo esc_attr( $key ); ?>"
															<?php echo in_array( (string) $key, (array) $select_user_from_switch, true ) ? esc_attr( 'selected' ) : ''; ?> />
															<?php echo esc_attr( $from_switch_role ); ?>
													</option>
												<?php } ?>
											</select><br>
	<?php 
	echo esc_html__( 'Leave empty to apply on all user roles', 'koala-multiple-customer-addresses' );
}

function address_title_callback() {
	?>
		  <select name="address_title_tag_key_field">  

			<option value="h1"
	<?php
	if ( 'h1' == get_option( 'address_title_tag_key_field ' ) ) {
		echo 'selected="selected"';
	}
	?>
			>
	<?php echo esc_html__( 'h1', 'koala-multiple-customer-addresses' ); ?></option>  
			<option value="h2"
	<?php
	if ( 'h2' == get_option( 'address_title_tag_key_field ' ) ) {
		echo 'selected="selected"';
	}
	?>
			><?php echo esc_html__( 'h2', 'koala-multiple-customer-addresses' ); ?></option>
			<option value="h3"
	<?php
	if ( 'h3' == get_option( 'address_title_tag_key_field ' ) ) {
		echo 'selected="selected"';
	}
	?>
			><?php echo esc_html__( 'h3', 'koala-multiple-customer-addresses' ); ?></option>
			<option value="h4"
	<?php
	if ( 'h4' == get_option( 'address_title_tag_key_field ' ) ) {
		echo 'selected="selected"';
	}
	?>
			><?php echo esc_html__( 'h4', 'koala-multiple-customer-addresses' ); ?></option>
			<option value="h5"
	<?php
	if ( 'h5' == get_option( 'address_title_tag_key_field ' ) ) {
		echo 'selected="selected"';
	}
	?>
			><?php echo esc_html__( 'h5', 'koala-multiple-customer-addresses' ); ?></option>
			<option value="h6"
	<?php
	if ( 'h6' == get_option( 'address_title_tag_key_field ' ) ) {
		echo 'selected="selected"';
	}
	?>
			><?php echo esc_html__( 'h6', 'koala-multiple-customer-addresses' ); ?></option>
			 </select><br> 
			 <?php echo esc_html__( 'Select which html tag has to be used to render the addresses title', 'koala-multiple-customer-addresses' ); ?>

	<?php
}


function default_address_label_callback() {
	 $address_label = get_option( 'default_address_key_field' );

	?>
	<input type="text" name="default_address_key_field" id="default_address_id" value="<?php echo esc_attr( $address_label ); ?>"> <br>
	<?php echo esc_html__( 'Add custom label for default address.', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function default_select_label_callback() {
	 $select_label = get_option( 'default_select_key_field' );
	?>
	<input type="text" name="default_select_key_field" id="default_select_id" value="<?php echo esc_attr( $select_label ); ?>"> <br>
	<?php echo esc_html__( 'Add custom label for select option.', 'koala-multiple-customer-addresses' ); ?>
	<?php
}


function custom_css_myaccount_callback() {
	?>
	
		<textarea name="custom_css_account_key_field" rows="6" cols="60" id="custom_css_account_id"          value="<?php echo esc_attr( get_option( 'custom_css_account_id' ) ); ?>"><?php echo esc_attr( get_option( 'custom_css_account_key_field' ) ); ?>
		</textarea>

	<br>
	<?php echo esc_html__( 'Define here your custom CSS', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function custom_css_checkout_callback() {
	?>
	
		<textarea name="custom_css_checkout_key_field" rows="6" cols="60" id="custom_css_checkout_id"          value="<?php echo esc_attr( get_option( 'custom_css_checkout_id' ) ); ?>"><?php echo esc_attr( get_option( 'custom_css_checkout_key_field' ) ); ?>
		</textarea>

	<br>
	<?php echo esc_html__( 'Define here your custom CSS', 'koala-multiple-customer-addresses' ); ?>
	<?php
}

function text_color_add_address_checkout_callback() {
	?>
			<div class="ajax_scrole_fld_hide">
			<input type="color" id="favcolor" name="text_color_add_address_checkout" value="<?php echo esc_attr( get_option( 'text_color_add_address_checkout' ) ); ?>">
			<br>
				<p><i>
				<?php esc_html_e( 'Text color for Add new address tag on checkout page', 'infinite_scrole' ); ?>
				</i></p>
			</div> 		
		<?php
}

