<?php
add_settings_section(
	'shipping',
	'',
	'shipping_callback',
	'shipping_settings'
);
function shipping_callback() { }

add_settings_field(
	'enable_disable_shipping',
	__( 'Disable shipping multiple addresses ', 'general_option_multiple_address' ),
	'disable_shipping_callback',
	'shipping_settings',
	'shipping'
);
register_setting(
	'shipping-page',
	'enable_disable_shipping'
);

add_settings_field(
	'max_num_shipping',
	__( 'Max number of shipping addresses ', 'general_option_multiple_address' ),
	'max_number_of_shipping_callback',
	'shipping_settings',
	'shipping'
);
register_setting(
	'shipping-page',
	'max_num_shipping'
);

add_settings_field(
	'disable_user_add_del_shipping',
	__( 'Disable user add/edit/delete shipping addresses capabilities ', 'general_option_multiple_address' ),
	'disable_user_update_shipping_cap_callback',
	'shipping_settings',
	'shipping'
);
register_setting(
	'shipping-page',
	'disable_user_add_del_shipping'
);
add_settings_field(
	'require_company_field_shipping',
	__( 'Shipping company name - enabled required ', 'general_option_multiple_address' ),
	'require_company_shipping_name_callback',
	'shipping_settings',
	'shipping'
);
register_setting(
	'shipping-page',
	'require_company_field_shipping'
);
add_settings_field(
	'add_shipping_email_option',
	__( 'Add shipping email field to Shipping addresses ', 'general_option_multiple_address' ),
	'add_shipping_email_field_callback',
	'shipping_settings',
	'shipping'
);
register_setting(
	'shipping-page',
	'add_shipping_email_option'
);

add_settings_field(
	'require_shipping_email',
	__( 'Is shipping email field required', 'general_option_multiple_address' ),
	'require_shipping_email_callback',
	'shipping_settings',
	'shipping'
);
register_setting(
	'shipping-page',
	'require_shipping_email'
);
add_settings_field(
	'add_shipping_phone_option',
	__( 'Add shipping phone number field to Shipping addresses', 'general_option_multiple_address' ),
	'add_shipping_phone_field_callback',
	'shipping_settings',
	'shipping'
);
register_setting(
	'shipping-page',
	'add_shipping_phone_option'
);
add_settings_field(
	'require_shipping_phone',
	__( 'Is shipping phone number field required', 'general_option_multiple_address' ),
	'require_shipping_phone_callback',
	'shipping_settings',
	'shipping'
);
register_setting(
	'shipping-page',
	'require_shipping_phone'
);
add_settings_field(
	'shipping_title_key_field',
	__( 'Shipping Button Text', 'general_option_multiple_address' ),
	'shipping_button_title_callback',
	'shipping_settings',
	'shipping'
);
register_setting(
	'shipping-page',
	'shipping_title_key_field'
);
add_settings_field(
	'shipping_checkout_heading',
	__( 'Shipping Checkout page Heading', 'general_option_multiple_address' ),
	'shipping_checkout_page_heading_callback',
	'shipping_settings',
	'shipping'
);
register_setting(
	'shipping-page',
	'shipping_checkout_heading'
);
add_settings_field(
	'shipping_myaccount_heading',
	__( 'Shipping myaccount page Heading', 'general_option_multiple_address' ),
	'shipping_myaccount_page_heading_callback',
	'shipping_settings',
	'shipping'
);
register_setting(
	'shipping-page',
	'shipping_myaccount_heading'
);
add_settings_field(
	'hide_add_new_check_ship',
	__( 'Hide shipping add new address tag(checkout)', 'general_option_multiple_address' ),
	'hide_add_new_check_ship_callback',
	'shipping_settings',
	'shipping'
);
register_setting(
	'shipping-page',
	'hide_add_new_check_ship'
);


function disable_shipping_callback() {
	$getvalship = get_option( 'enable_disable_shipping' );
	?>
	<input type="checkbox" name="enable_disable_shipping" id="disable_billing" value="1"<?php checked( $getvalship, '1' ); ?>><?php esc_html_e( 'Disable', 'koala-multiple-customer-addresses' ); ?><br>
	<?php echo esc_html__( 'Disabled Multiple billing address', 'koala-multiple-customer-addresses' ); ?>
	<?php
}

function max_number_of_shipping_callback() {
	$max_addresses_shipping = get_option( 'max_num_shipping' );
	if ( '' == $max_addresses_shipping ) {
		$max_addresses_shipping = '0';
	}
	?>
	<input type="number" min="0" name="max_num_shipping" id="max_size_shipping" value="<?php echo esc_attr( $max_addresses_shipping ); ?>"><br>
	<?php echo esc_html__( 'Max no of shipping addresses. Leave 0 for no limits.', 'koala-multiple-customer-addresses' ); ?>
	<?php
}

function disable_user_update_shipping_cap_callback() {
	$diable_cap_shipping = get_option( 'disable_user_add_del_shipping' );

	?>
	
	<input type="checkbox" name="disable_user_add_del_shipping" id="disable_cap_shipping" value="1"<?php checked( $diable_cap_shipping, '1' ); ?>><?php esc_html_e( 'Disable', 'koala-multiple-customer-addresses' ); ?><br>
	<?php echo esc_html__( 'Disable user to insert, delete and edit the existing shipping addresses.', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function require_company_shipping_name_callback() {
	 $require_company_shipping = get_option( 'require_company_field_shipping' );

	?>
	<input type="checkbox" name="require_company_field_shipping" id="require_company_shipping" value="1"<?php checked( $require_company_shipping, '1' ); ?>><?php esc_html_e( 'Enable', 'koala-multiple-customer-addresses' ); ?><br>
	<?php echo esc_html__( 'Make shipping company field required', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function add_shipping_email_field_callback() {
	$add_shipping_email = get_option( 'add_shipping_email_option' );

	?>
	<input type="checkbox" name="add_shipping_email_option" id="add_shipping_email_field" value="1"<?php checked( $add_shipping_email, '1' ); ?>><?php esc_html_e( 'Enable', 'koala-multiple-customer-addresses' ); ?><br>
	<?php echo esc_html__( 'This option adds an email field to the shipping addresses and to the Checkout shipping form.', 'koala-multiple-customer-addresses' ); ?>
	<?php
}

function require_shipping_email_callback() {
	$require_email = get_option( 'require_shipping_email' );

	?>
	<input type="checkbox" name="require_shipping_email" id="require_shipping_email_id" value="1"<?php checked( $require_email, '1' ); ?>><?php esc_html_e( 'Enable', 'koala-multiple-customer-addresses' ); ?><br>
	<?php echo esc_html__( 'The shipping email field will be mandatory', 'koala-multiple-customer-addresses' ); ?>
	<?php
}

function add_shipping_phone_field_callback() {
	$add_shipping_phone = get_option( 'add_shipping_phone_option' );

	?>
	<input type="checkbox" name="add_shipping_phone_option" id="add_shipping_phone_field" value="1"<?php checked( $add_shipping_phone, '1' ); ?>><?php esc_html_e( 'Enable', 'koala-multiple-customer-addresses' ); ?><br>
	<?php echo esc_html__( 'This option adds a phone field to shipping addresses and to the Checkout shipping form.', 'koala-multiple-customer-addresses' ); ?>
	<?php
}

function require_shipping_phone_callback() {
	$require_phone = get_option( 'require_shipping_phone' );
	?>
	<input type="checkbox" name="require_shipping_phone" id="require_shipping_phone_id" value="1"<?php checked( $require_phone, '1' ); ?>><?php esc_html_e( 'Enable', 'koala-multiple-customer-addresses' ); ?><br>
	<?php echo esc_html__( 'Make the shipping phone number field will be mandatory.', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function shipping_button_title_callback() {
	 $shipping_label = get_option( 'shipping_title_key_field' );

	?>
	<input type="text" name="shipping_title_key_field" id="shipping_title_id" value="<?php echo esc_attr( $shipping_label ); ?>"> <br>
	<?php echo esc_html__( 'Add custom text for shipping button.', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function shipping_checkout_page_heading_callback() {
	 $shipping_checkout = get_option( 'shipping_checkout_heading' );
	?>
	<input type="text" name="shipping_checkout_heading" id="shipping_checkout_heading_id" value="<?php echo esc_attr( $shipping_checkout ); ?>"> <br>
	<?php echo esc_html__( 'Add custom text on checkout page(Shipping detail).', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function shipping_myaccount_page_heading_callback() {
	 $shipping_myaccount = get_option( 'shipping_myaccount_heading' );
	?>
	<input type="text" name="shipping_myaccount_heading" id="shipping_myaccount_heading_id" value="<?php echo esc_attr( $shipping_myaccount ); ?>"> <br>
	<?php echo esc_html__( 'Add custom text on myaccount page(Shipping detail).', 'koala-multiple-customer-addresses' ); ?>
	<?php
}
function hide_add_new_check_ship_callback() {
	$hide_new_check = get_option( 'hide_add_new_check_ship' );
	?>
	<input type="checkbox" name="hide_add_new_check_ship" id="hide_add_new_check_ship_id" value="1"<?php checked( $hide_new_check, '1' ); ?>><?php esc_html_e( 'Disable', 'koala-multiple-customer-addresses' ); ?><br>
	<?php echo esc_html__( 'Checkout page hide add shipping addresses tag', 'koala-multiple-customer-addresses' ); ?>
	<?php
}


